#
# must.rb
#
#   Copyright (c) 1999 Minero Aoki <aamine@dp.u-netsurf.ne.jp>
#
# usage:
#
#   str.must String
#   str = (arg.must String)
#   arg.must String, Array
#   arg.needed :each
#

require 'amstd/common'


class Object

  def must( *args )
    args.each {|c| return self if c === self }
    raise TypeError, "wrong arg type '#{type}' for required #{args.join('/')}"
  end

  def needed( *args )
    args.each do |m|
      unless self.respond_to? m then
        nm = case arg
             when String then m
             when Fixnum then m.id2name
             end
        tos = self.inspect
        tos = tos[0, 15] + '...' if tos.size > 15
        raise ArgumentError, "arg #{tos}(#{type}) does not have #{nm}"
      end
    end
    self
  end

end
